require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_GRID_LIST 			= '/api/rtnmng/inoutmng/retstock-result-grid-list';	// 목록
const API_MOBILE_INFO 				= '/api/rtnmng/po/info-pchOdr';						// 상세
const API_POP_SEARCH_LIST			= '/api/whs/mng/pop-whs-search';
const API_POP_SPPLY_LIST 			= '/api/spply/pop-grid-list';

const PAGE_MODE_LIST				= "LIST";
const PAGE_MODE_VIEW				= "VIEW";

let mobPageObj = {
	viewMode: PAGE_MODE_LIST,
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.view();
			this.info();
		},
		view: function() {
			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});

			if(fn_make_user_info.get('authTpCd') === '50') {
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_BTN_MRTNMNG06010_LIST_SEARCH_SPPLY_NM').attr('disabled', true);
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_BTN_MRTNMNG06010_LIST_DELETE_SPPLY_NM').attr('disabled', true);
			}

			// 조회일자 지정
			$('#ITP_MOBILE_MRTNMNG06010 .itp_input.date').datepicker(ITP_DATE_LANGUAGE);
			$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH_FROM_DT').datepicker('setDate', itp_fn_date_add('D', -7));
			$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH_TO_DT').datepicker('setDate', itp_fn_date_add('M', 0));
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MRTNMNG06010_LIST"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MRTNMNG06010_LIST_SEARCH_WHS_NM'		: mobPopObj.popWhsNm.init(); 	break;
					case 'ITP_BTN_MRTNMNG06010_LIST_DELETE_WHS_NM'		: mobPopObj.popWhsNm.delete(); 	break;
					case 'ITP_BTN_MRTNMNG06010_LIST_SEARCH_SPPLY_NM'	: mobPopObj.popSpply.init(); 	break;
					case 'ITP_BTN_MRTNMNG06010_LIST_DELETE_SPPLY_NM'	: mobPopObj.popSpply.delete(); 	break;
					case 'ITP_BTN_MRTNMNG06010_LIST_SEARCH'				: mobContObj.list.search();		break;
				}
				return false;
			});

			$(document).on('click', '#ITP_LIST_MRTNMNG06010_LIST_ITEM_ROWS li', function() {
				var item = mobContObj.list.rows[$(this).index()];
				mobContObj.view.init(item);
			});

			$(document).on('click', '#ITP_POP_MRTNMNG06010_LIST_SPPLY_ROWS li button', function() {
				mobPopObj.popSpply.choice($(this));
			});

			$(document).on('click', '#ITP_LIST_MRTNMNG06010_POP_WHS_ROWS li button', function() {
				mobPopObj.popWhsNm.choice($(this));
			});
		}
	},
	switchScreen: function(mode) {
		$('#ITP_MOBILE_MRTNMNG06010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode === PAGE_MODE_LIST) {
			$('#ITP_AJAX_MRTNMNG06010_LIST_CONTAINER').show();
		}
		this.viewMode = mode;
	},
	ready: function() {
		mobContObj.list.init();
	}
};

let mobContObj = {
	list: {
		listPage: 1,
		rows: [],
		init: function() {
			mobPageObj.switchScreen(PAGE_MODE_LIST);
			this.search();
		},
		search: function() {
			var formId = '#ITP_FORM_MRTNMNG06010_LIST_SEARCH';
			this.listPage = 1;
			this.rows.length = 0;
			$('#ITP_LIST_MRTNMNG06010_LIST_ITEM_ROWS').empty();
			setTimeout(function() {
				mobContObj.list.load();
			}, 100);
		},
		pager: function(totPage) {
			(this.listPage < totPage) ?
				CommonObj.moreView('#ITP_LIST_MRTNMNG06010_LIST_ITEM_AREA', true, mobContObj.list.load) :
				CommonObj.moreView('#ITP_LIST_MRTNMNG06010_LIST_ITEM_AREA', false);
			this.listPage += 1;
		},
		load: function() {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				mobContObj.list.pager(result.gridTotal);
				$.each(result.gridRows, function (i, item) {
					$('#ITP_LIST_MRTNMNG06010_LIST_ITEM_AREA .panel-group').append($('#ITP_LIST_MRTNMNG06010_LIST_ITEM_ROWCOPY').html());
					var $li = $('#ITP_LIST_MRTNMNG06010_LIST_ITEM_AREA .panel-group > .item-row:last');
					$li.find('.fnRtnPodrNo').text(item.rtnPodrUnqNo);
					$li.find('.fnColCmpltDt').text(item.colCmpltDt);
					$li.find('.fnColSchDt').text(item.colSchDt);
					$li.find('.fnSpplyNm').text(item.spplyNm);
					$li.find('.fnRtnWhsNm').text(item.rtnWhsNm);
					$li.find('.fnItemNm').text(item.itemNm);
					$li.find('.fnColReqQty').text(CommonObj.comma.set(item.colReqQty));
					$li.find('.fnRodrQty').text(CommonObj.comma.set(item.rodrQty));
					mobContObj.list.rows.push(item);
				});
			};
			const param = $('#ITP_FORM_MRTNMNG06010_LIST_SEARCH').serializeObject();
			param.gridPage = mobContObj.list.listPage;
			param.gridSize = mobile_list_size;
			console.log(JSON.stringify(param));
			fn_ajax_call(API_MOBILE_GRID_LIST, JSON.stringify(param), callbackFn, 'POST');
		}
	}
};

let mobPopObj = {
	popSpply: {
		popId: 'ITP_POP_MRTNMNG06010_SPPLY_AREA',
		rows: [],
		init: function() {
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function() {
			var _this = this;
			$('#ITP_POP_MRTNMNG06010_LIST_SPPLY_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			let param = $('#ITP_FORM_MRTNMNG06010_POP_SPPLY_SEARCH').serializeObject();
			fn_ajax_call(API_POP_SPPLY_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_POP_MRTNMNG06010_LIST_SPPLY_AREA .panel-group').append($('#ITP_POP_MRTNMNG06010_LIST_SPPLY_ROWCOPY').html());
				var $li = $('#ITP_POP_MRTNMNG06010_LIST_SPPLY_AREA .panel-group > .row_2:last');
				$li.find('.fnSpplyNm').text(item.spplyNm);
				$li.find('.fnStNm').text($li.find('.fnStNm').text().replace('$', item.stNm));
				$li.find('.fnSpplyId').data('item-key', item.spplyId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var spplyId = $(elem).data('item-key');
			$.each(this.rows, function (i, item) {
				if(spplyId === item.spplyId) {
					$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_SPPLY_ID').val(item.spplyId);
					$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_SPPLY_NM').val(item.spplyNm);
					_this.close();
					return false;
				}
			});
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MRTNMNG06010_POP_SPPLY"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MRTNMNG06010_POP_SPPLY_SEARCH'	: _this.search();			break;
					case 'ITP_BTN_MRTNMNG06010_POP_SPPLY_CHOICE'	: _this.choice($(this));	break;
					case 'ITP_BTN_MRTNMNG06010_POP_SPPLY_CLOSE'	: _this.close(); 			break;
				}
				return false;
			});
		},
		delete: function() {
			$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_SPPLY_ID').val('');
			$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_SPPLY_NM').val('');
		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MRTNMNG06010_LIST_SPPLY_AREA .panel-group').empty();
			$('#ITP_FORM_MRTNMNG06010_POP_SPPLY_SEARCH #ITP_FORM_MRTNMNG06010_POP_SPPLY_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	popWhsNm: {
		popId: 'ITP_POP_MRTNMNG06010_WHS_AREA',
		rows: [],
		init: function (mode) {
			this.popMode = mode;
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function () {
			var _this = this;
			$('#ITP_LIST_MRTNMNG06010_POP_WHS_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			const param = $('#ITP_FORM_MRTNMNG06010_POP_WHS').serializeObject();
			// param.swhsDvsn = (fn_make_user_info.get('authTpCd') === '50') ? 'W02' : '';
			param.swhsDvsn = CommonObj.schWhsDvsn(true);
			fn_ajax_call(API_POP_SEARCH_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_LIST_MRTNMNG06010_POP_WHS_AREA .panel-group').append($('#ITP_LIST_MRTNMNG06010_POP_WHS_ROWCOPY').html());
				var $li = $('#ITP_LIST_MRTNMNG06010_POP_WHS_AREA .panel-group > .row_2:last');
				$li.find('.fnWhsNm').text(item.whsNm);
				$li.find('.fnLocationNm').text(item.locationNm);
				$li.find('.fnWhsId').data('whs-id', item.whsId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var whsId = $(elem).data('whs-id');
			$.each(this.rows, function (i, item) {
				if(whsId === item.whsId) {
					if(_this.popMode === 'RTN_WHS') {
						$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_RTN_WHS_ID').val(item.whsId);
						$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_RTN_WHS_NM').val(item.whsNm);
					} else {
						$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_WHS_ID').val(item.whsId);
						$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_WHS_NM').val(item.whsNm);
					}
					_this.close();
					return false;
				}
			});
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MRTNMNG06010_POP_WHS"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MRTNMNG06010_POP_WHS_SEARCH'	: _this.search();			break;
					case 'ITP_BTN_MRTNMNG06010_POP_WHS_CHOICE'	: _this.choice($(this)); 	break;
					case 'ITP_BTN_MRTNMNG06010_POP_WHS_CLOSE'	: _this.close(); 			break;
				}
				return false;
			});
		},
		delete: function() {
			if(this.popMode === 'RTN_WHS') {
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_RTN_WHS_ID').val('');
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_RTN_WHS_NM').val('');
			} else {
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_WHS_ID').val('');
				$('#ITP_FORM_MRTNMNG06010_LIST_SEARCH #ITP_FORM_MRTNMNG06010_LIST_SEARCH_WHS_NM').val('');
			}
		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MRTNMNG06010_LIST_WHS_AREA .panel-group').empty();
			$('#ITP_FORM_MRTNMNG06010_POP_WHS #ITP_FORM_MRTNMNG06010_POP_WHS_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	show: function(popId) {
		$('button[id$="_CLOSE"]').off('click').on('click', function() {
			console.log($(this).attr('id'));
			if($(this).hasClass('btn-pop-close')) {
				mobPopObj.hide(popId);
			}
		});
		$('#' + popId).show();
	},
	hide: function(popId) {
		$('#' + popId).closest('.mobile-pop-close').hide();
	}
};
